@ECHO OFF

REM This batch file compiles a Win32 resource containing the application icon
REM and then compiles Digger to assume the required resource files are not linked in
REM as managed resources. The resource files are Digger.ico, Font.png, Sprite.png and Level.bin
REM THese resource files are required to be in the same directory as the generated exe (Digger.exe)

CLS

ECHO *** Deleting old executable (if present) ***
ECHO.

IF EXIST Digger.exe DEL Digger.exe

ECHO *** Compiling the icon into a resource file ***
ECHO.

brcc32 Digger.rc
IF ERRORLEVEL 1 GOTO BadExit

ECHO.
ECHO *** Deleting command-line compiler config file (if present) ***

IF EXIST Digger.cfg DEL Digger.cfg

ECHO.
ECHO *** Compiling Digger to use external resource files ***
ECHO.

dccil -B -DUSE_OBJECT_BOXING Digger.dpr
IF ERRORLEVEL 1 GOTO BadExit

ECHO.
ECHO *** Verifying generated executable ***

peverify Digger.exe

ECHO.
ECHO *** Showing generated executable details ***
ECHO.

DIR Digger.exe

ECHO.
ECHO *** Launching Digger ***

start Digger.exe

GOTO Exit

:BadExit

ECHO.
ECHO An error occurred during the build process
PAUSE
GOTO Exit

:Exit