program Digger;

// Digger for .NET by Lutz Roeder, June 2000 (http://www.aisto.com/roeder).
// Graphics and Levels taken from the original version by Alexander Lang and Jan Fricke.
// Translated to Delphi for .NET by Brian Long, August 2002 (http://www.blong.com)

//Changes in Delphi version include:
// - the use of meaningful constants and variable names throughout
// - the use of Delphi sets where appropriate
// - some methods renamed for clarity
// - some code tidied up (redundant code removed and some logic bugs fixed)
// - removal of the panel (the game is now drawn directly on the form)
// - change from using .NET type info (GetType) to using the "is" operator

// Supported conditional defines:
// ------------------------------

// Class references don't work yet.
// You get the type in the declaration, not the correct one at runtime
// If USE_CLASS_REFS is defined, class references are used,
// otherwise .NET type info is used instead

// Managed resources cannot currently be linked in by Delphi for .NET
// However you can work around this limitation using creative round tripping
// (disassembling, modifying and reassembling)
// If LINK_RESOURCES is defined, the code expects the managed resources to
// be linked in, otherwise it works off files in the same directory
// Digger uses resource files for the form icon, the sprite images,
// the font data and the level data

// Range checking isn't currently reliable
// If USE_RANGE_CHECKING is defined, range checking will be used,
// otherwise it won't be

// Some of the original C# code used object boxing (e.g. turning
// integers to objects, so methods can be called on them).
// If USE_OBJECT_BOXING is defined, object boxing is used (in DiggerMainForm)
// otherwise the Format function is used instead

// Include icon for Windows Explorer
// This is a non-managed resource and can be linked in just fine
{$R Digger.res}

//To do:
// - use class statics as in the original
// - use attributes
// - use properties
// - use nested types as in the original

uses
  Oblong.Vcl.Controls,
  DiggerMainForm in 'DiggerMainForm.pas',
  DiggerFont in 'DiggerFont.pas',
  DiggerLevel in 'DiggerLevel.pas';

begin
  MainForm := TMainForm.Create;
  TApplication.Run(MainForm)
end.
